package net.sf.gluebooster.demos.pojo.flashcards;

import net.sf.gluebooster.demos.pojo.languages.chinese.ChineseAppDefinition;
import net.sf.gluebooster.demos.pojo.refactor.AppDefinition;
import net.sf.gluebooster.demos.pojo.refactor.TransformerByInvoking;
import net.sf.gluebooster.demos.pojo.refactor.TransformerToConstant;

/**
 * Definition of the Flashcard-App.
 * 
 * @author cbauer
 *
 */
public class FlashcardAppDefinition extends AppDefinition {

	/**
	 * The command to load the cards.
	 */
	public static final String COMMAND_LOAD_CARDS = "Load cards";

	/**
	 * The command to save the cards.
	 */
	public static final String COMMAND_SAVE_CARDS = "Save cards";

	/**
	 * The command to put the current card into the right compartment. Parameter is whether the current card is known (true), not known (false) or no info about
	 * the current card (null)
	 */
	public static final String COMMAND_NEXT_CARD = "Next card";

	public static final String FIELD_ALL_FLASHCARDS = "All flashcards";

	public static final String FIELD_DISPLAYED_FLASHCARD_SIDE = "Displayed flashcard side";

	public static final String FIELD_FLASHCARDS_STATISTICS = "Flashcard statistics";

	/**
	 * The singleton instance. No instanciation yet, because the other static constants are not yet defined;
	 */
	public static final TransformerToConstant<FlashcardAppDefinition> singleton = TransformerToConstant
			.createWithInitializer(TransformerByInvoking.createNewInstanceInvokingTransformer(FlashcardAppDefinition.class));

	public FlashcardAppDefinition() {
		setTitle("Flashcards");
	}

}
