package net.sf.gluebooster.demos.pojo.flashcards;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Map;

import net.sf.gluebooster.demos.pojo.refactor.AppControllerAbstraction;
import net.sf.gluebooster.demos.pojo.refactor.AppDefinition;
import net.sf.gluebooster.demos.pojo.refactor.gb.AppControllerImpl;
import net.sf.gluebooster.java.booster.essentials.utils.XmlBoostUtils;

/**
 * A default controller for FlashcardsAppView.
 * 
 * 
 * @author CBauer
 *
 */
public class FlashcardsAppController<CardElement> extends AppControllerImpl {

	/**
	 * 
	 * @param definition
	 *            the defiition
	 * @throws Exception
	 */
	public FlashcardsAppController() throws Exception {
		super(FlashcardAppDefinition.singleton.getValue());
	}

	/**
	 * Constructor with model.
	 * 
	 * @param model
	 *            the model of the controller
	 */
	public FlashcardsAppController(Map model) throws Exception {
		super(FlashcardAppDefinition.singleton.getValue());
		setModel(model);
	}

	@Override
	public boolean executeCommandImpl(String commandName, Object parameter) throws Exception {
		if (super.executeCommandImpl(commandName, parameter)) {
			return true;
		} else {

			Map<Object, Object> model = getModel();
			// TODO: the model should not save or load.
			if (FlashcardAppDefinition.COMMAND_SAVE_CARDS.equals(commandName)) {
				File file = (File) parameter;
				// model.saveCards((File) parameter);
				FileOutputStream stream = new FileOutputStream(file);
				XmlBoostUtils.writeAsUtf8Xml(model.get(FlashcardAppDefinition.FIELD_ALL_FLASHCARDS), stream, true, 0);
				// stream.close();

				// TODO put feedback into model
			} else if (FlashcardAppDefinition.COMMAND_LOAD_CARDS.equals(commandName)) {
				File file = (File) parameter;
				FileInputStream stream = new FileInputStream(file);
				model.put(FlashcardAppDefinition.FIELD_ALL_FLASHCARDS, XmlBoostUtils.readFromXml(stream));
				// model.loadCards((File) parameter);
			} else if (AppDefinition.COMMAND_START.equals(commandName)) {
				// DO INITIALIZATIONS WHEN NECESSARY
			} else if (FlashcardAppDefinition.COMMAND_NEXT_CARD.equals(commandName)) {
				((Flashcards<CardElement>) model.get(FlashcardAppDefinition.FIELD_ALL_FLASHCARDS)).getNextCard((Boolean) parameter);
				model.put(FlashcardAppDefinition.FIELD_DISPLAYED_FLASHCARD_SIDE,
						((Flashcards<CardElement>) model.get(FlashcardAppDefinition.FIELD_ALL_FLASHCARDS)).getCurrentFrontsideString());
				model.put(FlashcardAppDefinition.FIELD_FLASHCARDS_STATISTICS,
						((Flashcards<CardElement>) model.get(FlashcardAppDefinition.FIELD_ALL_FLASHCARDS)).getSizeInfo().toString());

			} else {
				return false;
			}
			return true;
		}
	}
}
