package net.sf.gluebooster.demos.pojo.languages.chinese;

import java.io.File;
import java.util.Map;

import net.sf.gluebooster.demos.pojo.refactor.AppDefinition;
import net.sf.gluebooster.demos.pojo.refactor.DialogConfiguration;
import net.sf.gluebooster.demos.pojo.refactor.gb.AppViewImpl;
import net.sf.gluebooster.java.booster.basic.events.UserInteraction;
import net.sf.gluebooster.java.booster.essentials.utils.IoBoostUtils;

/**
 * Default view without gui.
 * 
 * @author cbauer
 *
 */
public class ChineseAppView extends AppViewImpl<ChineseAppController, ChineseAppDefinition> {

	public ChineseAppView() throws Exception {
		super(ChineseAppDefinition.singleton.getValue());
	}

	@Override
	protected boolean execute(Object commandName, Object parameter) throws Exception {
		if (AppDefinition.COMMAND_START.equals(commandName)) {
			// nothing to do yet

		} else if (ChineseAppDefinition.COMMAND_CHANGE_TRADITIONAL_TO_SIMPLIFIED.equals(commandName)
				|| ChineseAppDefinition.COMMAND_CREATE_VOCABULARY.equals(commandName) || ChineseAppDefinition.COMMAND_EXTRACT_CHARACTERS.equals(commandName)) {
			Map<Object, Object> model = controllerCommand(commandName, getDisplayModel().get(ChineseAppDefinition.FIELD_ORIGINAL_TEXT));
			Object resultText = model.get(ChineseAppDefinition.FIELD_TRANSFORMED_TEXT);
			getDisplayModel().put(ChineseAppDefinition.FIELD_TRANSFORMED_TEXT, resultText);
			IoBoostUtils.setClipboard("" + resultText);

		} else if (ChineseAppDefinition.COMMAND_SORT_TEXT.equals(commandName)) {
			Map<Object, Object> model = controllerCommand(commandName, getDisplayModel().get(ChineseAppDefinition.FIELD_ORIGINAL_TEXT),
					getDisplayModel().get(ChineseAppDefinition.FIELD_TRANSFORMED_TEXT));
			Object resultText = model.get(ChineseAppDefinition.FIELD_TRANSFORMED_TEXT);
			getDisplayModel().put(ChineseAppDefinition.FIELD_TRANSFORMED_TEXT, resultText);
			IoBoostUtils.setClipboard("" + resultText);
		} else {
			return false;
		}
		return true;
	}

}
