package net.sf.gluebooster.demos.pojo.languages.chinese;

import javax.swing.JTextArea;

import net.sf.gluebooster.demos.pojo.refactor.AppDisplayBySwingBorderLayout;
import net.sf.gluebooster.demos.pojo.refactor.AppViewAbstraction;
import net.sf.gluebooster.demos.pojo.refactor.SwingBoostUtils;
import net.sf.gluebooster.demos.pojo.refactor.gb.AppInitializer;

/**
 * {@Feature}A demo application to support learning chinese.{@FeatureEnd}
 * 
 * @author cbauer
 *
 */
public class ChineseDemo extends AppInitializer {

	/**
	 * Starts the application
	 * 
	 * @param ignored
	 *            parameters are ignored
	 */
	public static void main(String[] ignored) throws Exception {
		startSampleApp();
	}

	/**
	 * Starts the application
	 * 
	 * @return the view of the application
	 */
	public static AppDisplayBySwingBorderLayout startSampleApp() throws Exception {

		// AbstractAppView.startApplication(ChineseAppController.class, null, ChineseAppView.class, ChineseAppDisplaySwing.class);
		ChineseAppController controller = new ChineseAppController();
		ChineseAppView view = new ChineseAppView();
		ChineseDemo demo = new ChineseDemo();
		AppDisplayBySwingBorderLayout display = demo.createSwingLayout(view);
		// FlashcardsAppDisplaySwing display = new FlashcardsAppDisplaySwing(view);
		AppViewAbstraction.startApplication(view, controller);
		return display;
	}

	/**
	 * Creates a layout of the application with swing components.
	 * 
	 * @param view
	 *            the view of the application
	 * @return the created layout
	 */
	private AppDisplayBySwingBorderLayout createSwingLayout(ChineseAppView view) throws Exception {
		AppDisplayBySwingBorderLayout result = new AppDisplayBySwingBorderLayout(view, ChineseAppDefinition.singleton.getValue());

		result.setSouth(SwingBoostUtils.createPanel(
				result.createButton("Traditional (left) -> Simplified (right)", ChineseAppDefinition.COMMAND_CHANGE_TRADITIONAL_TO_SIMPLIFIED),
				result.createButton("Create Vocabulary from Text", ChineseAppDefinition.COMMAND_CREATE_VOCABULARY),
				result.createButton("Extract characters", ChineseAppDefinition.COMMAND_EXTRACT_CHARACTERS),
				result.createButton("Sort", ChineseAppDefinition.COMMAND_SORT_TEXT)));

		result.setWest(result.putComponentIntoDisplayModel(ChineseAppDefinition.FIELD_ORIGINAL_TEXT, new JTextArea(100, 50)));

		result.setEast(result.putComponentIntoDisplayModel(ChineseAppDefinition.FIELD_TRANSFORMED_TEXT, new JTextArea(100, 50)));

		// result.addToMenuBar(result.createMenu("Options", "Change dictionary", ChineseAppDefinition.COMMAND_LOAD_DICTIONARY));
		addMenuConfiguration(result);


		return result;
	}
}
