package net.sf.gluebooster.demos.pojo.languages.chinese;

import java.util.List;

import org.apache.commons.lang3.tuple.Pair;

/**
 * One entry in the CC-CEDICT format.
 * 
 * http://cc-cedict.org/wiki/format:syntax
 * 
 * @author CBauer
 *
 */
public class ChineseVocabularyEntry {

	/**
	 * The traditional notation.
	 */
	private String traditional;
	/**
	 * The simplified notation.
	 */
	private String simplified;

	/**
	 * The different pinyin transcriptions and the corresponding translations.
	 */
	private List<Pair<String, List<String>>> pinyinTranslations;

	public ChineseVocabularyEntry() {

	}

	public String getTraditional() {
		return traditional;
	}

	public void setTraditional(String traditional) {
		this.traditional = traditional;
	}

	public String getSimplified() {
		return simplified;
	}

	public void setSimplified(String simplified) {
		this.simplified = simplified;
	}

	public List<Pair<String, List<String>>> getPinyinTranslations() {
		return pinyinTranslations;
	}

	public void setPinyinTranslations(
			List<Pair<String, List<String>>> pinyinTranslations) {
		this.pinyinTranslations = pinyinTranslations;
	}

	@Override
	public String toString() {

		return "" + traditional + " " + simplified + " " + pinyinTranslations;
	}

}
