package net.sf.gluebooster.demos.pojo.planning.blockworld;

import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.Name;
import javax.naming.spi.ObjectFactory;

import net.sf.gluebooster.demos.pojo.planning.Plan;
import net.sf.gluebooster.demos.pojo.planning.Planning;
import net.sf.gluebooster.demos.pojo.refactor.Operation;
import net.sf.gluebooster.java.booster.basic.container.BoostedNode;

import org.apache.commons.lang3.tuple.ImmutablePair;

/**
 * Calculates concrete objects to replace virtual objects.
 * 
 * @author CBauer
 * 
 */
public class BlockworldVirtualObjectInstantiator implements ObjectFactory {

	/**
	 * Always returns the first hand found in the blockworld.
	 */
	@Override
	public Object getObjectInstance(Object boostedNodeWithVirtualObject,
			Name ignored, Context ignoredCtx,
			Hashtable<?, ?> environmentWithPlan) throws Exception {
		Plan<Table, String> plan = Planning
				.getPlanFromHashtable(environmentWithPlan);
		Table instance = plan.getWorldInstanceDescription();
		Operation<Table, String> operation = Operation
				.getOperation((BoostedNode) boostedNodeWithVirtualObject);
		if (!Blockworld.OPERATOR_NEW_VIRTUAL_OBJECT.equals(operation
				.getOperator())) {
			throw new IllegalStateException(
					"Expected OPERATOR_NEW_VIRTUAL_OBJECT, got "
					+ operation.getOperator());
		}
		Hand virtualHand = operation.getOperatorDetails();
		return new ImmutablePair<Hand, Hand>(virtualHand, instance.getHands()
				.iterator().next());
	}


}
