package net.sf.gluebooster.demos.pojo.refactor;

import java.util.Collection;

import javax.naming.spi.ObjectFactory;

/**
 * Selects elements from a collection.
 * 
 * TODO add more types of selection
 * 
 * @author CBauer
 *
 */
public class CollectionSelector<CollectionElement> extends
		BoostedObjectFactory<Collection<CollectionElement>, CollectionElement>
		implements ObjectFactory {

	/**
	 * Create a selector that selects the first element of a collection.
	 * 
	 * @return the created selector.
	 */
	public static <CollectionElement> CollectionSelector<CollectionElement> createSelectFirstElementSelector() {
		return new CollectionSelector<CollectionElement>();
	}


	@Override
	public CollectionElement transform(Collection<CollectionElement> input) {
		if (input.isEmpty())
			return null;
		else
			return input.iterator().next();
	}


}
