package net.sf.gluebooster.demos.pojo.refactor;


/**
 * Commands to be processed. Replace the class
 * net.sf.gluebooster.java.booster.essentials.sourcecode.Command by this
 * implementation and move the class into the meta package.
 * 
 * @author CBauer
 * 
 */
public class Command<Parameters> {

	/**
	 * The command to be processed.
	 */
	private String command;

	/**
	 * Parameters of the command. These may be the actual parameters or a
	 * parameter description, etc.
	 */
	private Parameters parameters;

	/**
	 * Indentation of new lines.
	 */
	private CharSequence indentation;

	/**
	 * Default constructor.
	 */
	public Command() {

	}

	/**
	 * Constructor with details
	 */
	public Command(String command, Parameters parameters,
			CharSequence indentation) {
		this.command = command;
		this.parameters = parameters;
		this.indentation = indentation;
	}

	/**
	 * @Getter
	 */
	public String getCommand() {
		return command;
	}

	/**
	 * @Setter
	 */
	public void setCommand(String command) {
		this.command = command;
	}

	/**
	 * @Getter
	 */
	public Parameters getParameters() {
		return parameters;
	}

	/**
	 * @Setter
	 */
	public void setParameters(Parameters parameters) {
		this.parameters = parameters;
	}

	/**
	 * @Getter
	 */
	public CharSequence getIndentation() {
		return indentation;
	}

	/**
	 * @Setter
	 */
	public void setIndentation(CharSequence indentation) {
		this.indentation = indentation;
	}

}
