package net.sf.gluebooster.demos.pojo.refactor;

import java.util.Collection;

/**
 * A handler or invoker of commands. Refactor into the net.sf.gluebooster.java.booster.essentials.meta
 * 
 * @author CBauer
 * 
 * @param <CommandDescription>
 *            the description of the command. May be String (only the name) * TODO replace this class by the MethodDescriptor-class and add the following
 *            methods to the FeatureDescriptorBoostUtils - set/get returnDescriptor ParameterDescriptor (add as attribute)
 * 
 * @param <Parameter>
 *            The value of the parameter of the command
 * @param <Result>
 *            The result of the execution of the command
 */
public interface CommandHandler<CommandDescription, Parameter, Result> {

	/**
	 * Gets the commands that are supported by this handler.
	 * 
	 * @return the supported commands
	 */
	// Collection<CommandDescription> getSupportedCommands();

	/**
	 * Execute a command
	 * 
	 * @param commandName
	 *            identifies the command
	 * @param parameter
	 *            the paramete of the command
	 * @return the result of the execution
	 */
	Result executeCommand(CommandDescription commandName, Parameter parameter)
			throws Exception;

}
