package net.sf.gluebooster.demos.pojo.refactor;

import java.util.Map;

/**
 * Utilities for copying.
 * 
 * @author cbauer
 * @defaultParamText source the source to copy from
 * @defaultParamText target the targets to copy to
 * @defaultParamText keys the keys which values are to be copied
 *
 */
public class CopyBoostUtils {

	/**
	 * Copies some attributes from a source to a target
	 */
	public static void copyAttributes(HasAttributes source, HasAttributes target, Object... keys) throws Exception {
		for (Object key : keys) {
			target.setAttribute(key, source.getAttribute(key));
		}
	}

	/**
	 * Copies some entries from a source to a target
	 */
	public static void copyEntries(Map source, Map target, Object... keys) throws Exception {
		for (Object key : keys) {
			target.put(key, source.get(key));
		}
	}

}
