package net.sf.gluebooster.demos.pojo.refactor;

/**
 * Contains a yes/no information.
 * 
 * @author CBauer
 *
 */
public class Flag {

	/**
	 * The value of this flag.
	 */
	private Boolean value;

	/**
	 * Should an exception be throw if the condition that is implied by the
	 * value is not met.
	 */
	private boolean throwExceptionIfValueIsNotFulfilled = false;

	/**
	 * A prefix before the text of the exception
	 */
	private String exceptionTestPrefix = "";

	public Flag() {
	}

	public Flag(Boolean value) {
		this(value, true);
	}

	public Flag(Boolean value, boolean throwExceptionIfValueIsNotFulfilled) {
		this.value = value;
		this.throwExceptionIfValueIsNotFulfilled = throwExceptionIfValueIsNotFulfilled;
	}

	public Flag(Boolean value, String exceptionTestPrefix) {
		this(value, true);
		this.exceptionTestPrefix = exceptionTestPrefix;
	}

	public Boolean getValue() {
		return value;
	}

	public void setValue(Boolean value) {
		this.value = value;
	}

	public boolean isThrowExceptionIfValueIsNotFulfilled() {
		return throwExceptionIfValueIsNotFulfilled;
	}

	public void setThrowExceptionIfValueIsNotFulfilled(
			boolean throwExceptionIfValueIsNotFulfilled) {
		this.throwExceptionIfValueIsNotFulfilled = throwExceptionIfValueIsNotFulfilled;
	}

	public String getExceptionTestPrefix() {
		return exceptionTestPrefix;
	}

	public void setExceptionTestPrefix(String exceptionTestPrefix) {
		this.exceptionTestPrefix = exceptionTestPrefix;
	}

}
