package net.sf.gluebooster.demos.pojo.refactor;

import java.awt.Shape;

import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.graph.UndirectedSparseGraph;

/**
 * Refactor into the basic class
 * 
 * @author cbauer
 *
 */
public class JungGraphBoostUtils extends net.sf.gluebooster.java.booster.basic.math.JungGraphBoostUtils {

	/**
	 * Copies a graph.
	 * 
	 * @param graph
	 *            the graph to copy
	 * @return the copy
	 */
	public static <V, E> Graph<V, E> copy(Graph<V, E> graph) {
		Graph<V, E> result = new UndirectedSparseGraph<V, E>();
		for (V vertex : graph.getVertices()) {
			result.addVertex(vertex);
		}
		for (E edge : graph.getEdges()) {
			edu.uci.ics.jung.graph.util.Pair<V> endpoints = graph.getEndpoints(edge);
			result.addEdge(edge, endpoints.getFirst(), endpoints.getSecond());
		}

		return result;
	}
}
