package net.sf.gluebooster.demos.pojo.refactor;

import java.util.Iterator;
import java.util.NoSuchElementException;
import java.util.regex.Matcher;

/**
 * Iterates over match results.
 * 
 * @author cbauer
 *
 */
public class MatcherIterator implements Iterator {

	/**
	 * The input sequence used by the matcher
	 */
	private String input;

	/**
	 * The matcher
	 */
	private Matcher matcher;

	/**
	 * The result of the last find invocation.
	 */
	private Boolean lastFindResult = null;

	/**
	 * 
	 * @param matcher
	 * @param input
	 *            the matcher must already be reset to the input
	 */
	public MatcherIterator(Matcher matcher, CharSequence input) {
		this.input = input.toString();
		this.matcher = matcher;
	}

	@Override
	public boolean hasNext() {

		if (lastFindResult == null) {
			lastFindResult = matcher.find();
		}

		return lastFindResult;
	}

	@Override
	public Object next() {
		if (!hasNext()) {
			throw new NoSuchElementException("no next element");
		}

		return input.substring(matcher.start(), matcher.end());
	}

	@Override
	public void remove() {
		throw new UnsupportedOperationException("remove not yet supported");

	}

}
