package net.sf.gluebooster.demos.pojo.refactor;

import net.sf.gluebooster.demos.pojo.refactor.ObjectDescription;
import net.sf.gluebooster.java.booster.essentials.meta.ValueDescription;

/**
 * Refactor into the ObjectDescription.
 * 
 * 
 * @author cbauer
 *
 */
public class ObjectDescriptionBoostUtils {

	/**
	 * Create a description of an object.
	 * 
	 * @param name
	 *            the name of the object
	 * @param description
	 *            the description of the objet
	 * @param valueClass
	 *            the class the object is an instance of.
	 * @return the created description
	 */
	public static ObjectDescription create(String name, String description, Class valueClass) {
		ObjectDescription result = new ObjectDescription(name, description);
		result.setValueDescription(new ValueDescription(valueClass));
		return result;
	}
}
