package net.sf.gluebooster.demos.pojo.refactor;

import java.io.File;
import java.util.concurrent.CancellationException;

import javax.swing.JFileChooser;

import net.sf.gluebooster.java.booster.basic.gui.swing.JOptionPaneUserInteraction;
import net.sf.gluebooster.java.booster.essentials.utils.SwingBoostUtils;

/**
 * User interaction by using the JOptionPane and JFileChooser.
 * 
 * TODO move the code from JOptionPaneUserInteraction into this class and remove SwingBoostUtils
 * 
 * @author cbauer
 *
 */
public class SwingUserInteraction extends JOptionPaneUserInteraction implements UserInteraction {

	@Override
	public String showInputDialog(DialogConfiguration configuration) throws Exception {
		return showInputDialog(configuration.getMessage(), configuration.getInitialValue());
	}

	@Override
	public int showConfirmDialog(DialogConfiguration configuration) throws Exception {
		return showConfirmDialog(configuration.getParent(), configuration.getMessage(), configuration.getTitle(), configuration.getDialogType());

	}

	@Override
	public File showFileDialog(DialogConfiguration dialog) throws Exception {
		File file = null;

		JFileChooser chooser = new JFileChooser();
		chooser.setDialogTitle(dialog.getTitle());
		File initialFile = null;
		Object value = dialog.getInitialValue();
		if (value != null) {
			File dir = null;
			if (value instanceof File) {
				dir = (File) value;
			} else {
				dir = new File(value.toString());
			}
			initialFile = dir;

			if (!dir.isDirectory()) {
				chooser.setSelectedFile(dir);
				dir = dir.getParentFile();
			}
			chooser.setCurrentDirectory(dir);

		}
		if (DialogConfiguration.TYPE_CHOOSE_DIRECTORY == dialog.getDialogType())
			chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		int returnVal = chooser.showOpenDialog(null);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			file = chooser.getSelectedFile();
		}

		if (file != null && !file.exists() && dialog.isResultMustExist()) {
			file = null;
		}

		if (file == null && dialog.isThrowExceptionIfNothingSelected()) {
			throw new CancellationException("No (existing) file selected");
		} else {
			if (file == null && dialog.isReturnValueIfCancelled()) {
				file = initialFile;
			}
			return file;
		}

	}



}
