package net.sf.gluebooster.demos.pojo.refactor;

import java.io.File;

/**
 * Interaction with the user.
 * 
 * @author CBauer
 * @defaultParamText message the displayed message
 * @defaultParamText configuration the configuration of the dialog
 * 
 */
public interface UserInteraction {
	

	/**
	 * Show an input dialog. See JOptionPane for description and details.
	 * 
	 * @param initialSelectionValue
	 *            the initial value.
	 * @return the entered string
	 */
	@Deprecated
	String showInputDialog(Object message, Object initialSelectionValue);

	/**
	 * Show an input dialog with a given configuration
	 * 
	 * @return the entered text of the dialog.
	 */
	String showInputDialog(DialogConfiguration configuration) throws Exception;

	/**
	 * Show a confirm dialog. See JOptionPane for description and details.
	 * 
	 * @param parentComponent
	 *            the parent component of the created dialog
	 * @param title
	 *            the title of the dialog
	 * @param optionType
	 *            the type of the options
	 * @return an int indicating the option selected by the user
	 */
	@Deprecated
	int showConfirmDialog(Object parentComponent,
	        Object message, String title, int optionType); 

	/**
	 * Show a confirm dialog with a given configuration.
	 * 
	 * @return the result of the dialog. see JOptionPane.
	 */
	int showConfirmDialog(DialogConfiguration configuration) throws Exception;

	/**
	 * Show a file dialog
	 * 
	 * @return the selected file (null if no file is selected)
	 */
	File showFileDialog(DialogConfiguration configuration) throws Exception;
}
