package net.sf.gluebooster.demos.pojo.refactor.gb;

import net.sf.gluebooster.demos.pojo.refactor.AppDefinition;
import net.sf.gluebooster.demos.pojo.refactor.AppDisplayBySwingBorderLayout;

/**
 * Methods to initialize the apps.
 * 
 * @author cbauer
 *
 */
public abstract class AppInitializer {

	/**
	 * Adds default entries to the menu bar. Entries are: Configuration load, edit, save.
	 * 
	 * @param display
	 *            the display to which menu bar the entries are added
	 */
	protected void addMenuConfiguration(AppDisplayBySwingBorderLayout display) {
		display.addToMenuBar(display.createMenu("Configuration", "Load", AppDefinition.COMMAND_LOAD_CONFIGURATION, "Edit",
				AppDefinition.COMMAND_EDIT_CONFIGURATION, "Save", AppDefinition.COMMAND_SAVE_CONFIGURATION));
		
	}

}
