package net.sf.gluebooster.demos.pojo.flashcards;

import java.awt.event.MouseEvent;
import java.io.File;

import javax.swing.JFrame;

import org.junit.Test;

import net.sf.gluebooster.demos.pojo.refactor.AppDisplayBySwingBorderLayout;
import net.sf.gluebooster.demos.pojo.refactor.ExtendedTestRoot;
import net.sf.gluebooster.java.booster.essentials.meta.Example;

public class FlashcardDemoTest extends ExtendedTestRoot {

	/**
	 * An example to learn with flashcards.
	 * 
	 * 
	 * @throws Exception
	 */
	@Test
	@Example(clasz = FlashcardDemo.class)
	public void flashcardDemo() throws Exception {
		File directory = createTempDirectory("images");

		// [gb:useInDocumentation]
		AppDisplayBySwingBorderLayout layout = FlashcardDemo.startSimpleSwingDemo(null);
		// no flashcard is displayed yet, the number of flashcards in the first compartmant is displayed below the menu

		JFrame frame = layout.getFrame();
		FlashcardsAppView view = (FlashcardsAppView) layout.getViewLogic();
		MouseEvent leftClick = new MouseEvent(frame, MouseEvent.MOUSE_CLICKED, System.currentTimeMillis(), MouseEvent.BUTTON1_MASK, 1, 1, 1, false,
				MouseEvent.BUTTON1);
		MouseEvent rightClick = new MouseEvent(frame, MouseEvent.MOUSE_CLICKED, System.currentTimeMillis(), MouseEvent.BUTTON2_MASK, 1, 1, 1, false,
				MouseEvent.BUTTON2);
		createScreenshot(directory, "step1", frame);
		// </pre><img src="images/step1.png"/><pre>

		view.mouseClicked(leftClick);
		// the front side is displayed
		createScreenshot(directory, "step2", frame);
		// </pre><img src="images/step2.png"/><pre>

		view.mouseClicked(leftClick);
		// the back side is displayed
		createScreenshot(directory, "step3", frame);
		// </pre><img src="images/step3.png"/><pre>

		// mark the card as known
		view.mouseClicked(leftClick);

		// the next front side is displayed and the compartments have changed: a new compartment with 1 card is created (at the right).
		createScreenshot(directory, "step4", frame);
		// </pre><img src="images/step4.png"/><pre>

		view.mouseClicked(leftClick);
		// the back side is displayed
		createScreenshot(directory, "step5", frame);
		// </pre><img src="images/step5.png"/><pre>

		// mark the card as not known. If the card has been known prviously the compartments change: the first compartment has one more card and the compartment
		// of the current card has one card less.
		view.mouseClicked(rightClick);

		// the next front side is displayed
		createScreenshot(directory, "step6", frame);
		// </pre><img src="images/step6.png"/><pre>
		// [/gb:useInDocumentation]

		copyExampleResultFiles(directory);
		// frame.setVisible(false);
		frame.dispose();
	}
}
