package net.sf.gluebooster.demos.pojo.refactor;

import net.sf.gluebooster.java.booster.basic.container.BoostedNode;
import net.sf.gluebooster.java.booster.basic.container.SimpleBoostedNode;

import org.junit.Assert;
import org.junit.Test;

public class BoostedNodeGraphTest {

	@Test
	public void testRemoveNode() throws Exception {

		// Test1: create a simple graph node1 -> node2 and remove node1

		String NODE1 = "node1";
		SimpleBoostedNode<String> node1 = new SimpleBoostedNode<String>();
		node1.setName(NODE1);
		node1.getAttributes().setValue(NODE1);

		String NODE2 = "node2";
		SimpleBoostedNode<String> node2 = new SimpleBoostedNode<String>();
		node2.setName(NODE2);
		node2.getAttributes().setValue(NODE2);

		Refactor.addEdge(node1, node2);

		BoostedNodeGraph graph = new BoostedNodeGraph(node1);

		graph.removeNode(node1);

		Assert.assertTrue(graph.getSomeNodesOfTheConnectedComponents()
				.contains(node2));
		// node2 must have no predecessor
		for (BoostedNode inpoint : node2.getInPoints()) {
			Assert.assertTrue(node2.getPredecessorOutPoints(inpoint).isEmpty());
		}
	}
}
