package net.sf.gluebooster.demos.pojo.refactor;

import java.awt.Component;
import java.io.File;

import javax.swing.JFrame;

import net.sf.gluebooster.java.booster.basic.gui.GuiBoostUtils;
import net.sf.gluebooster.java.booster.essentials.TestRoot;
import net.sf.gluebooster.java.booster.essentials.utils.ThreadBoostUtils;

import org.junit.Assert;

public class ExtendedTestRoot extends TestRoot {

	protected void createScreenshot(File directory, String filenamewithoutEnding, Component component) throws Exception {
		ThreadBoostUtils.sleep(5000);// wait for some time, so that the component is displayed fully and not transparent
		GuiBoostUtils.writeImage(GuiBoostUtils.createScreenshot(component), new File(directory, filenamewithoutEnding + ".png"));
	}

	protected <CommandDescription> void createScreenshotInThread(final File directory, final String filenamewithoutEnding, final Component component,
			final CommandHandler<CommandDescription, ?, ?> commandHandler, final CommandDescription commandBeforeScreenshot,
			final CommandDescription commandAfterScreenshot) throws Exception {

		// the screenshotter makes the screenshot and does the comandAfterScreenshot.
		// The command before screenshot is done separately, because it may display a dialog and wait until the dialog is closed
		Runnable screenshotter = new Runnable() {

			@Override
			public void run() {

				try {
					createScreenshot(directory, filenamewithoutEnding, component);
				} catch (Exception ex) {
					getLog().error(ex);
					Assert.fail("Exception occured: " + ex);
				}

				try {
					commandHandler.executeCommand(commandAfterScreenshot, null);
				} catch (Exception ex) {
					getLog().error(ex);
					Assert.fail("Exception occured: " + ex);
				}
			}
		};
		Thread thread = new Thread(screenshotter);
		thread.start();
		commandHandler.executeCommand(commandBeforeScreenshot, null);
		// wait for the thread to end
		long maxTime = System.currentTimeMillis() + 120000; // wait at most 2 minutes
		while (thread.isAlive() && System.currentTimeMillis() < maxTime) {
			ThreadBoostUtils.sleep(1000);
		}
	}

	protected File writeTextfileAndCreateScreenshot(File file, CharSequence text, int width, int height, File screenshotDirectory, String screenshotName)
			throws Exception {
		JFrame textframe = SwingBoostUtils.createFiletextFrame(text, file, width, height);
		textframe.setVisible(true);
		createScreenshot(screenshotDirectory, screenshotName, textframe);
		textframe.dispose();
		return file;
	}


}
