package net.sf.gluebooster.demos.pojo.refactor;

import java.awt.event.MouseEvent;
import java.util.Map;

import javax.naming.spi.ObjectFactory;

import junit.framework.Assert;
import net.sf.gluebooster.java.booster.basic.container.BoostedNode;
import net.sf.gluebooster.java.booster.essentials.objects.BoostedObject;
import net.sf.gluebooster.java.booster.essentials.utils.ContainerBoostUtils;

import org.junit.Test;

import edu.uci.ics.jung.visualization.control.GraphMouseListener;

public class TransformationGraphTest extends BoostedObject {

	@Test
	public void testGetObjectInstance() throws Exception {

		String PAGE = "page";
		String TEXT = "text";
		String MY_TEXT = "my text";

		TransformationGraph transformationGraph = TransformationGraph
				.createChain(
						new TransformerToConstant<Map>(ContainerBoostUtils
								.createMap(PAGE, Integer.valueOf(1), TEXT,
										MY_TEXT)),
						new TransformerBySelectingAnElement<ObjectFactory>(TEXT));

		GraphDisplayConfiguration<TransformationNode<?>, String> displayConfiguration = TransformationGraph
				.createDefaultDisplayConfiguration();
		displayConfiguration
				.setClickListener(new GraphMouseListener<TransformationNode<?>>() {

					@Override
					public void graphReleased(TransformationNode<?> v,
							MouseEvent me) {
					}

					@Override
					public void graphPressed(TransformationNode<?> v,
							MouseEvent me) {
					}

					@Override
					public void graphClicked(TransformationNode<?> v,
							MouseEvent me) {
						getLog().info(v);
						getLog().info("IN-Points");
						for (BoostedNode in : v.getInPoints()) {
							getLog().info(in);
						}
						getLog().info("OUT-Points");
						for (BoostedNode out : v.getOutPoints()) {
							getLog().info(out);
						}
					}
				});

		transformationGraph.simpleDisplay(displayConfiguration);
		Object result = transformationGraph.getObjectInstance(null, null, null,
				null);

		Assert.assertEquals(MY_TEXT, result);
	}
}
